<?php
/**
 * š꡼
 */

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/forms/EditLeaguedetailForm.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbLeague.class.php";

class BBSB_EditLeaguedetailAction extends BBSB_AbstractEditAction
{
	/**
	 * ꡼ǡ(1쥳ʬ)
	 * @var unknown_type
	 */
	var $mLgList				= null;

    /**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditGamedetailAction#_setupActionForm()
     */
    function _setupActionForm()
	{
		$this->mActionForm =& new BBSB_EditLeaguedetailForm();
		$this->mActionForm->prepare();
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}

			// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		if( xoops_getrequest('lid') ){
			// lidȤ(ϻ)
			$lid = xoops_getrequest('lid');

			// lidɳդǡ
			$dbLg = new BBSB_DbLeague();
			$dbLg->setData( 'LeagueID', $lid );
			$this->mLgList = $dbLg->getListbyCond( 'bb_league', _BBSB_FALSE_IS_ALL_COL, _BBSB_LIMIT_1 );

			// ꡼ǡեǤ˥å
			$this->mActionForm->mFormProperties['lid']->mValue			= $this->mLgList[0]['LeagueID'];	// LeagueID
			$this->mActionForm->mFormProperties['leaguename']->mValue	= $this->mLgList[0]['LeagueName'];	// ֥꡼̾
			$this->mActionForm->mFormProperties['url']->mValue			= $this->mLgList[0]['Url'];			// URL
			$this->mActionForm->mFormProperties['syncurl']->mValue		= $this->mLgList[0]['SyncUrl'];		// ֻǡƱURL
		}

		return BBSB_FRAME_VIEW_INPUT;
	}

	/**
	 * ꡼ǡοϿorϿ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		// 󥻥
		if( !xoops_getrequest('entry') ){
			return BBSB_FRAME_VIEW_CANCEL;
		}

		$this->mActionForm->load($this->mObject);	// DBͤɬפ硢ǥǡɤ롩
		$this->mActionForm->fetch();				// ꥯȥեफͤμ
		$this->mActionForm->validate();				// ͭͤ

		// 顼ϥեɽ
		if($this->mActionForm->hasError()) {
			return BBSB_FRAME_VIEW_INPUT;
		}

		// ʹߡ顼åOKν
		// ==============================================================================

		// ꡼ơ֥Ͽ(bb_league)
		$dbLg =& new BBSB_DbLeague();		// ꡼ǡѤDB󥹥
		$dbLg->setData( 'LeagueName',	$this->mActionForm->mFormProperties['leaguename']->mValue );
		$dbLg->setData( 'Url',			$this->mActionForm->mFormProperties['url']->mValue );
		$dbLg->setData( 'SyncUrl',		$this->mActionForm->mFormProperties['syncurl']->mValue );

		// LeagueIDȤUPDATE(¸ǡԽ)ʤINSERT()
		if( $this->mActionForm->mFormProperties['lid']->mValue ){
			// ¸ǡԽUPDATE
			$keyarray = array( 'LeagueID'=>$this->mActionForm->mFormProperties['lid']->mValue );
			$result = $dbLg->update( 'bb_league', $keyarray );
			if( $result===false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
		} else {
			// INSERT
			$result = $dbLg->insert( 'bb_league' );
			if( $result===false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
		}

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * եѥӥ塼
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewInput(&$controller, &$xoopsUser, &$render)
	{
		if( $this->mMobile ){
			$render->setTemplateName("bbsb_editleaguedetailM.html");
		} else {
			$render->setTemplateName("bbsb_editleaguedetail.html");
			$render->setAttribute("xoops_module_header",	_BBSB_OP_CSSFILE );
		}
		$render->setAttribute("actionForm", $this->mActionForm);
	}

	/**
	 *  Ͽν
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewLeaguelist" );
	}

	/**
	 * Ͽ顼ν(DBι˼)
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * 󥻥ξν ꡼
	 */
	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewLeaguelist");
	}

}
?>
