<?php
/**
 * ܺɽ
 */

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbOpponent.class.php";

class BBSB_ViewOpponentdetailAction extends BBSB_AbstractEditAction
{
	/**
	 * ǡ(1ʬ)
	 * @var unknown_type
	 */
	var $mOpList				= null;

	/**
	 * å
	 * @var unknown_type
	 */
	var $mDelMsg				= null;

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}

		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		// tidɬ
		if( !xoops_getrequest('tid') ){
			$controller->executeForward(XOOPS_URL . '/');
		}
		$tid = xoops_getrequest('tid');

		// delϺ⡼()
		if( xoops_getrequest('del') ){
			$adminmode = null;
			if( is_object($controller->mRoot->mContext->mXoopsUser) ){
				$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
			}
			if( !$adminmode ){
				$controller->executeForward(XOOPS_URL . '/');
			}
			$this->mDelMsg = _MD_BBSB_INFO_DELCONFIRM;
		}

		// tidɳդǡ
		$dbOp = new BBSB_DbOpponent();
		$dbOp->setData( 'TeamID', $tid );
		$this->mOpList = $dbOp->getListbyCond( 'bb_opponent', _BBSB_FALSE_IS_ALL_COL, _BBSB_LIMIT_1 );

		return BBSB_FRAME_VIEW_INDEX;
	}

	/**
	 * ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		// delɬ
		if( !xoops_getrequest('del') ){
			$controller->executeForward(XOOPS_URL . '/');
		}
		$tid = xoops_getrequest('del');

		// delϺ⡼()
		$adminmode = null;
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		// 󥻥
		if( !xoops_getrequest('delbutton') ){
			return BBSB_FRAME_VIEW_CANCEL;
		}

		// ơ֥
		$dbOp = new BBSB_DbOpponent();
		$dbOp->setData( 'TeamID',	$tid );
		$ret = $dbOp->delete('bb_opponent');

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ǡɽؿ
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		if( $this->mMobile ){
			$render->setTemplateName("bbsb_viewopponentdetailM.html");	// Mobile
		} else {
			$render->setTemplateName("bbsb_viewopponentdetail.html");
			$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE);
		}

		// ǡեǡ˥å
		$this->mOpList[0]['LastGameDate'] = date("Y-m-d",strtotime($this->mOpList[0]['LastGameDate']));
		$render->setAttribute("oplist",			$this->mOpList);
		// Υå
		$render->setAttribute("delmsg",			$this->mDelMsg );

	}

	/**
	 * ΤȤ̤
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$del	= xoops_getrequest('del');
		if( $del ){
			$del = "&del=" . $del;
		}
		$controller->executeForward("./index.php?action=ViewOpponentlist" . $del );
	}

	/**
	 * Ͽ顼ν(DBι˼)
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * 󥻥ξν 
	 */
	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewOpponentlist");
	}

}
?>
