<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . '/' . _BBSB_DIRNAME . '/bbsb.inc.php';
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractDatabase.class.php";

/*
 * ơ֥륯饹
 */
class BBSB_DbGame extends BBSB_AbstractDatabase {

    /**
     * 󥹥ȥ饯
     */
    function BBSB_DbGame() {
        /* XCLDB쥯饹 */
        $root =& XCube_Root::getSingleton();
        $this->mDb =& $root->mController->mDB;
    }

    /**
     * ǯ٥ꥹȼ(쥳ɤ¸ߤǯ٤Τ߼ǯ٥ꥹȤȤ)
     * @return unknown_type
     */
    function getSelectNendoList(){
		$sqlstr =	" SELECT Nendo FROM " . $this->mDb->prefix('bb_game');
		$sqlstr .=	" GROUP BY Nendo ASC ";
    	return $this->getList( $sqlstr );
    }

    /**
     * ꡼/ťꥹȼ(쥳ɤ¸ߤ꡼Τ߼)
     * @return unknown_type
     */
    function getSelectLeagueList(){
		$sqlstr =	" SELECT L.LeagueID,LeagueName ";
		$sqlstr .=	" FROM " . $this->mDb->prefix('bb_game') . " G, " . $this->mDb->prefix('bb_league') . " L ";
		$sqlstr .=	" WHERE G.LeagueID=L.LeagueID ";
		$sqlstr .=	" GROUP BY LeagueID ASC ";
		return $this->getList( $sqlstr );
    }

    /**
     * /ȡʥȥꥹȼ(쥳ɤ¸ߤȡʥȤΤ߼)
     * @return unknown_type
     */
    function getSelectTournamentList(){
	    $sqlstr =	" SELECT T.TournamentID,TournamentName ";
		$sqlstr .=	" FROM " . $this->mDb->prefix('bb_game') . " G, " . $this->mDb->prefix('bb_tournament') . " T ";
		$sqlstr .=	" WHERE G.TournamentID=T.TournamentID ";
		$sqlstr .=	" GROUP BY TournamentID ASC ";
		return $this->getList( $sqlstr );
    }

    /**
     * ꥹȼ(쥳ɤ¸ߤΤ߼)
     * @return unknown_type
     */
    function getSelectGameOrderList(){
	    $sqlstr =	" SELECT GO.GameOrderID,GameOrderName ";
		$sqlstr .=	" FROM " . $this->mDb->prefix('bb_game') . " G, " . $this->mDb->prefix('bb_gameorder') . " GO ";
		$sqlstr .=	" WHERE G.GameOrderID=GO.GameOrderID ";
		$sqlstr .=	" GROUP BY GameOrderID ASC ";
		return $this->getList( $sqlstr );
    }

    /**
     * 饦ɥꥹȼ(饦ɥơ֥¸ߤ뤹٤ƤΥ饦ɥꥹȤǤϤʤżӤΤ륰饦ɤΤ߼)
     * @return unknown_type
     */
    function getSelectGroundList(){
		$sqlstr =	" SELECT GR.GroundID,GroundName ";
		$sqlstr .=	" FROM " . $this->mDb->prefix('bb_game') . " G, " . $this->mDb->prefix('bb_ground') . " GR ";
		$sqlstr .=	" WHERE G.GroundID=GR.GroundID";
		$sqlstr .=	" GROUP BY G.GroundID ASC ";
		return $this->getList( $sqlstr );
    }

    /**
     * ꥹȼ(ơ֥¸ߤƤꥹȤǤϤʤӤΤΤ߼)
     * @return unknown_type
     */
	function getSelectOpponentList(){
		$sqlstr =	" SELECT O.TeamID,TeamName ";
		$sqlstr .=	" FROM " . $this->mDb->prefix('bb_game') . " G, " . $this->mDb->prefix('bb_opponent') . " O ";
		$sqlstr .=	" WHERE G.FirstTeamID=O.TeamID or G.LastTeamID=O.TeamID ";
		$sqlstr .=	" GROUP BY TeamID ";
		$sqlstr .=	" ORDER BY LastGameDate IS NULL DESC, LastGameDate DESC ";
		$list = $this->getList( $sqlstr );
		// ꥹȤκǸ˹Ѥ(=0)ɲä
		$list[]=array('TeamID'=>0, 'TeamName'=>_BBSB_OP_OWNTEAMNAME."("._MD_BBSB_LANG_KOHAKUSEN.")");
		return $list;
	}

    /**
     * IDꤷƻꥹȤ(ǡԽѡ1Τ)
     * @return unknown_type
     */
    function getGameEditInfo( $gid ) {
		$sqlstr =	" SELECT GameID,Nendo,DATE_FORMAT(EventDate,'%Y-%c-%e') AS EventDate,GameSeq,";
		$sqlstr .=	"LeagueID,TournamentID,GameOrderID,GroundID,FirstTeamID,LastTeamID,Result,";
		$sqlstr .=	"FirstBattery,LastBattery,Inning01top,Inning01bottom,";
		$sqlstr .=	"Inning02top,Inning02bottom,Inning03top,Inning03bottom,Inning04top,Inning04bottom,";
		$sqlstr .=	"Inning05top,Inning05bottom,Inning06top,Inning06bottom,Inning07top,Inning07bottom,";
		$sqlstr .=	"Inning08top,Inning08bottom,Inning09top,Inning09bottom,Inning10top,Inning10bottom,";
		$sqlstr .=	"Inning11top,Inning11bottom,Inning12top,Inning12bottom,Inning13top,Inning13bottom,";
		$sqlstr .=	"Inning14top,Inning14bottom,Inning15top,Inning15bottom,Inning16top,Inning16bottom,";
		$sqlstr .=	"Inning17top,Inning17bottom,Inning18top,Inning18bottom,Inning19top,Inning19bottom,";
		$sqlstr .=	"Inning20top,Inning20bottom,Inning21top,Inning21bottom,Inning22top,Inning22bottom,";
		$sqlstr .=	"Inning23top,Inning23bottom,Inning24top,Inning24bottom,Inning25top,Inning25bottom,";
		$sqlstr .=	"ResultTop,ResultBottom,GameComment,UpdateTime ";
    	$sqlstr .=	" FROM " . $this->mDb->prefix('bb_game') . " WHERE GameID='" . $gid . "' LIMIT 1 ";
		return $this->getList( $sqlstr );
    }

    /**
     * ꥹȤ(ǡɽ)
     * @param $wherestr		Whereʸ
     * @param $limit		쥳ɿ
     * @param $sortstr		OrderBy
     * @param $listmode		⡼ɤܺ٥⡼ɤ
     * @return unknown_type
     */
    function getGameShowInfo( $wherestr, $limit=1, $sortstr=false, $listmode=false ){
		// SQLʸ
		$sqlstr =	" SELECT SQL_CALC_FOUND_ROWS GameID,Nendo,DATE_FORMAT(EventDate,'%Y/%c/%e') AS EventDate,GameSeq,Result,";
		$sqlstr .=	"FirstBattery,LastBattery,Inning01top,Inning01bottom,";
		$sqlstr .=	"Inning02top,Inning02bottom,Inning03top,Inning03bottom,Inning04top,Inning04bottom,";
		$sqlstr .=	"Inning05top,Inning05bottom,Inning06top,Inning06bottom,Inning07top,Inning07bottom,";
		$sqlstr .=	"Inning08top,Inning08bottom,Inning09top,Inning09bottom,Inning10top,Inning10bottom,";
		$sqlstr .=	"Inning11top,Inning11bottom,Inning12top,Inning12bottom,Inning13top,Inning13bottom,";
		$sqlstr .=	"Inning14top,Inning14bottom,Inning15top,Inning15bottom,Inning16top,Inning16bottom,";
		$sqlstr .=	"Inning17top,Inning17bottom,Inning18top,Inning18bottom,Inning19top,Inning19bottom,";
		$sqlstr .=	"Inning20top,Inning20bottom,Inning21top,Inning21bottom,Inning22top,Inning22bottom,";
		$sqlstr .=	"Inning23top,Inning23bottom,Inning24top,Inning24bottom,Inning25top,Inning25bottom,";
		$sqlstr .=	"Inning23top,Inning23bottom,Inning24top,Inning24bottom,Inning25top,Inning25bottom,";
		$sqlstr .=	"ResultTop,ResultBottom, ";
		$sqlstr .=	"LeagueName,TournamentName,GameOrderName,GroundName, ";
		$sqlstr .=	" CASE WHEN FirstTeamID='0' THEN '" . _BBSB_OP_OWNTEAMNAME . "' ELSE O1.TeamName END AS FirstTeamName, ";
		$sqlstr .=	" CASE WHEN LastTeamID='0'  THEN '" . _BBSB_OP_OWNTEAMNAME . "' ELSE O2.TeamName END AS LastTeamName, ";
		$sqlstr .=	"GR.Url AS GURL,L.Url AS LURL,O1.Url AS FTURL,O2.Url AS LTURL ";
		if( !$listmode ){	// ⡼ɤΤȤϥȡǽդ
			$sqlstr .= ",GameComment,UpdateTime ";
		}
		$sqlstr .=	" FROM " . $this->mDb->prefix('bb_game') . " G ";
		$sqlstr .=  " LEFT JOIN " . $this->mDb->prefix('bb_league')     . " L ON G.LeagueID=L.LeagueID ";
		$sqlstr .=	" LEFT JOIN " . $this->mDb->prefix('bb_tournament') . " T  ON G.TournamentID=T.TournamentID ";
		$sqlstr .=	" LEFT JOIN " . $this->mDb->prefix('bb_gameorder')  . " GO ON G.GameOrderID=GO.GameOrderID ";
		$sqlstr .=	" LEFT JOIN " . $this->mDb->prefix('bb_ground')     . " GR ON G.GroundID=GR.GroundID ";
		$sqlstr .=	" LEFT JOIN " . $this->mDb->prefix('bb_opponent')   . " O1 ON G.FirstTeamID=O1.TeamID ";
		$sqlstr .=	" LEFT JOIN " . $this->mDb->prefix('bb_opponent')   . " O2 ON G.LastTeamID=O2.TeamID ";
		$sqlstr .=	$wherestr;
		if( $sortstr ){
			$sqlstr .= $sortstr;
		}
		if( $limit ){
			$sqlstr .=	" LIMIT " . $limit;
		}
		$gary = $this->getList( $sqlstr );

		// ƥ˥󥰤ΥǡǤ򥻥å
		foreach( $gary as &$gdat ){
			$gdat['Itop'] = $gdat['Ibottom'] = array();
			for( $ccnt = 0 ; $ccnt < 25 ; $ccnt++ ){
				$top	= "Inning" . sprintf("%02d",$ccnt+1) . "top";
				$bottom	= "Inning" . sprintf("%02d",$ccnt+1) . "bottom";
				$gdat['Itop'][$ccnt]		= $gdat[$top];
				$gdat['Ibottom'][$ccnt]		= $gdat[$bottom];
				if( $gdat['Ibottom'][$ccnt]===null && $gdat['Itop'][$ccnt]!==null){
					$gdat['Ibottom'][$ccnt]="x";
				}
			}

			// 
			$resultList = array(	"0" => _MD_BBSB_LANG_GLOSE,			// 
									"1" => _MD_BBSB_LANG_GWIN,			// 
									"2" => _MD_BBSB_LANG_GEVEN,			// ʬ
									"3" => _MD_BBSB_LANG_GETC,			// ¾
									"11" => _MD_BBSB_LANG_LOTWIN,		// 
									"21" => _MD_BBSB_LANG_DEFAULTWIN,	// ﾡ
									"31" => _MD_BBSB_LANG_ETCWIN,		// ¾
									"10" => _MD_BBSB_LANG_LOTLOSE,		// 餱
									"20" => _MD_BBSB_LANG_DEFAULTLOSE,	// 
									"30" => _MD_BBSB_LANG_ETCLOSE);		// ¾餱
			$key = $gdat['Result'];
			$gdat['ResultStr'] = $resultList[$key];

			//   ֻܡפղä
			$gdat['GameSeq'] = $gdat['GameSeq'] . _MD_BBSB_LANG_GAMESEQ;
		}

		return $gary;
    }
}
?>