<?php
// եࡧϿ

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_ROOT_PATH . "/core/XCube_ActionForm.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbOpponent.class.php";

/***
 * ե९饹Ͽ
 */
class BBSB_EditOpponentdetailForm extends XCube_ActionForm
{
	function prepare()
	{
		// եץѥƥ
		$this->mFormProperties['tid']				=& new XCube_IntProperty('tid');				// ID
		$this->mFormProperties['teamname']			=& new XCube_StringProperty('teamname');		// ̾
		$this->mFormProperties['url']				=& new XCube_StringProperty('url');				// URL
		$this->mFormProperties['baseplace']			=& new XCube_StringProperty('baseplace');		// 
		$this->mFormProperties['fullname']			=& new XCube_StringProperty('fullname');		// ɽԻ̾
		$this->mFormProperties['phoneno']			=& new XCube_StringProperty('phoneno');			// 
		$this->mFormProperties['mphoneno']			=& new XCube_StringProperty('mphoneno');		// 
		$this->mFormProperties['memail']			=& new XCube_StringProperty('memail');			// ӥ᡼
		$this->mFormProperties['pcemail']			=& new XCube_StringProperty('pcemail');			// PC᡼
		$this->mFormProperties['comments']			=& new XCube_TextProperty('comments');			// 
		$this->mFormProperties['lastgamedate']		=& new XCube_StringProperty('lastgamedate');	// ǽ

		// ID
		$this->mFieldProperties['tid']			=& new XCube_FieldProperty($this);
		$this->mFieldProperties['tid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['tid']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_TEAMID, "5");
		$this->mFieldProperties['tid']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_TEAMID);
		$this->mFieldProperties['tid']->addVar('maxlength', 5);
		$this->mFieldProperties['tid']->addVar('min', '1');
		$this->mFieldProperties['tid']->addVar('max', '32767');

		// ̾(ɬ)
		$this->mFieldProperties['teamname']		=& new XCube_FieldProperty($this);
		$this->mFieldProperties['teamname']->setDependsByArray(array('required','maxlength'));
		$this->mFieldProperties['teamname']->addMessage('required',	_MD_BBSB_ERROR_REQUIRED,	_MD_BBSB_LANG_TEAMNAME);
		$this->mFieldProperties['teamname']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_TEAMNAME, '256');
		$this->mFieldProperties['teamname']->addVar('maxlength', 256);

		// URL
		$this->mFieldProperties['url']			=& new XCube_FieldProperty($this);
		$this->mFieldProperties['url']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['url']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,		_MD_BBSB_LANG_URL, '256');
		$this->mFieldProperties['url']->addVar('maxlength', 256);

		// 
		$this->mFieldProperties['baseplace']	=& new XCube_FieldProperty($this);
		$this->mFieldProperties['baseplace']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['baseplace']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_BASEPLACE, '256');
		$this->mFieldProperties['baseplace']->addVar('maxlength', 256);

		// ɽԻ̾
		$this->mFieldProperties['fullname']		=& new XCube_FieldProperty($this);
		$this->mFieldProperties['fullname']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['fullname']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_OP_REP, '128');
		$this->mFieldProperties['fullname']->addVar('maxlength', 128);

		// 
		$this->mFieldProperties['phoneno']		=& new XCube_FieldProperty($this);
		$this->mFieldProperties['phoneno']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['phoneno']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PHONENUMBER, '32');
		$this->mFieldProperties['phoneno']->addVar('maxlength', 32);

		// 
		$this->mFieldProperties['mphoneno']		=& new XCube_FieldProperty($this);
		$this->mFieldProperties['mphoneno']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['mphoneno']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_MOBILEPHONE, '32');
		$this->mFieldProperties['mphoneno']->addVar('maxlength', 32);

		// Email
		$this->mFieldProperties['memail']		=& new XCube_FieldProperty($this);
		$this->mFieldProperties['memail']->setDependsByArray(array('maxlength', 'email'));
		$this->mFieldProperties['memail']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,		_MD_BBSB_LANG_MOBILEEMAIL, '256');
		$this->mFieldProperties['memail']->addVar('maxlength', 256);
		$this->mFieldProperties['memail']->addMessage('email', _MD_BBSB_ERROR_EMAIL );

		// PCEmail
		$this->mFieldProperties['pcemail']		=& new XCube_FieldProperty($this);
		$this->mFieldProperties['pcemail']->setDependsByArray(array('maxlength', 'email'));
		$this->mFieldProperties['pcemail']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PCEMAIL, '256');
		$this->mFieldProperties['pcemail']->addVar('maxlength', 256);
		$this->mFieldProperties['pcemail']->addMessage('email', _MD_BBSB_ERROR_EMAIL );

		// 
		$this->mFieldProperties['comments']		=& new XCube_FieldProperty($this);
		$this->mFieldProperties['comments']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['comments']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_COMMENT, '10000');
		$this->mFieldProperties['comments']->addVar('maxlength', 10000);

		// ǽ
		$this->mFieldProperties['lastgamedate']	=& new XCube_FieldProperty($this);
		$this->mFieldProperties['lastgamedate']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['lastgamedate']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_LASTGAMEDATE, '10');
		$this->mFieldProperties['lastgamedate']->addVar('maxlength', 10);

	}

	/**
	 * ̾  ϥå
	 * @return unknown_type
	 *	ϻˡƱ̾Υ쥳ɤäϥ顼
	 */
	function validateTeamName()
	{
		if( $this->get('tid') ){
			$exarray = array( 'TeamID' => $this->get('tid') );		// TeamID(=)ϳ򥫥оݤˤʤ
		} else {
			$exarray = false;										// TeamIDʤ(=)
		}

		$dbOp = new BBSB_DbOpponent();
		$dbOp->setData( 'TeamName',	$this->get('teamname') );
		$count = $dbOp->CountNum( 'bb_opponent', $exarray );
		if( $count != 0 ){
			$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_DUPLICATE, _MD_BBSB_LANG_TEAMNAME));
		}
	}

	/**
	 * URL ϥå
	 * @return unknown_type
	 */
	function validateUrl()
	{
		$t_url = $this->get('url');
		if (strlen($t_url) > 0) {
			if (!preg_match('/^https?(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/', $t_url)) {
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_INJURY, _MD_BBSB_LANG_URL));
			}
		}
	}

	/**
	 * ǽå
	 * @return unknown_type
	 */
	function validateLastGameDate()
	{
		$lgd = $this->get('lastgamedate');
		if( !$lgd ){return;}
		$stamp = strtotime( $lgd );

		if (is_numeric($stamp))
		{
			$month = date( 'm', $stamp );
			$day   = date( 'd', $stamp );
			$year  = date( 'Y', $stamp );
			if (checkdate($month, $day, $year))
			{
				return;
			}
		}
		$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_INJURY, _MD_BBSB_LANG_LASTGAMEDATE));
	}

	/**
	 * 
	 * @see core/XCube_ActionForm#load($obj)
	 */
	function load(&$obj)
	{
	}

}
?>
